/*
 * Copyright 2024 Luca Fulchir <luca.fulchir@runesauth.com>
 *
 * Licensed under the Apache License, Version 2.0 with LLVM exception (the
 * "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License and of the exception at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *     https://spdx.org/licenses/LLVM-exception.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/// Example package
#[::bok::package(super::one::One)]
#[::bok::deps_build(super::one::One)]
pub struct Two {
    pub my_attr2: u32,
}

#[::bok::package_impl]
impl ::std::default::Default for Two {
    fn default() -> Self {
        Two {
            _bok_base: ::std::marker::PhantomData::default(),
            _bok_repo: ::std::marker::PhantomData::default(),
            my_attr: 2,
            my_attr2: 2,
            version: ::bok::Version {
                major: 0,
                minor: 0,
                patch: 2,
                pre: ::bok::Prerelease::EMPTY,
                build: ::bok::BuildMetadata::EMPTY,
            },
        }
    }
}

#[::bok::package_impl]
impl ::bok::Pkg for Two {
    fn dependencies_set(
        &self,
        repo: ::std::sync::Arc<dyn ::bok::Repository>,
        _build: &::bok::deps::Build,
        _runtime: &::bok::deps::Runtime,
    ) -> Result<(), ()> {
        let repo_any = repo.as_any();
        let Some(actual_repo) = repo_any.downcast_ref::<R>() else {
            return Err(());
        };
        let _ = actual_repo.one();

        Ok(())
    }
}
